Subject: bug#16992: feature request: background images

From: Eli Zaretskii <[email-masked]>
Date: Fri, 08 Nov 2024 20:50:35 +0200

> Date: Fri, 8 Nov 2024 17:42:48 +0100
> From: Cecilio Pardo <[email-masked]>
> 
> On 08/11/2024 16:46, Eli Zaretskii wrote:
> 
> > So showing a vertical line for the fill-column indication would need
> > to define a background image for a frame?  How do we control the
> > horizontal coordinate where the line is drawn?
> 
> No, the background image (if present) is drawn first, then 'dynamic' 
> things like the indicator are drawn over, with the corresponding drawing 
> api. We are doing both things. In the patch, the fill-column indicator 
> line is drawn by looking directly at the value of fill_column. But I 
> think it would be better to allow lisp to define multiple vertical 
> lines, with the desired position.

So what is the Lisp API for drawing those "dynamic" things?  AFAIU,
you've only shown the API to set a single static background image.

> > Btw, what happens when text is scrolled horizontally?
> 
> Nothing special. Besides redrawing everything.

Is the background image scrolled or isn't it?

> > Is this only going to work with fixed images?  Then I guess features
> > like showing vertical lines as indentation indicators, like those
> > here:
> > 
> >    https://techpress.net/how-to-show-hide-indent-dots-in-vscode/
> > 
> > will not be possible?
> 
> Yes. Those are not part of the image. We use the same mechanism to draw 
> on the background, but they are independent. We can use them without 
> background images at all.
> 
> Some of these things are easy to do, like the fill indicator, which 
> doesn't depend on the contents of the buffer. Indentation lines are much 
> more complex.

Those "dynamic" drawings are the most wanted feature that is currently
missing.  And the challenge is to implement them in a way that won't
make redisplay significantly slower, e.g. due to disabled
optimizations (like scrolling_window).